import es, cfglib, os, random

info = es.AddonInfo()
info.name = 'LooneyTrails'
info.version = '1.1'
info.url = 'http://addons/eventscripts.com/addons/view/LooneyTrails'
info.author = 'Satoon101'
es.ServerVar('looneytrails_version',info.version,'looneytrails_version').makepublic()

gamename = str(es.ServerVar('eventscripts_gamedir')).rsplit(os.sep,1)[~0]

TrailEffects = ['smoke','energy','sparks','dust','beam']

WeaponEntityList = {}

class EntityManager(object):
    class Entity:
        def __init__(self, entity, name):
            self.entity = entity
            self.name = name
            self.indexes = {}
            self.teams = {}
        
        def findIndexes(self):
            entlist = es.createentitylist(self.entity)
            remove = []
            for index in self.indexes:
                if not index in entlist:
                    remove.append(index)
            for index in remove:
                del self.indexes[index]
            for index in entlist:
                if not index in self.indexes:
                    self.indexes[index] = self.Index(index,self.teams[self.getTeamNum(index)],self.entity)
                if self.indexes[index].effect is None: continue
                self.indexes[index].createTrail()
        
        @staticmethod
        def getTeamNum(index):
            teamnum = es.getindexprop(index,'CBaseEntity.m_iTeamNum')
            if teamnum: return teamnum
            owner = es.getindexprop(index,'CBaseEntity.m_hOwnerEntity')
            for userid in es.getUseridList():
                if es.getplayerhandle(userid) == owner: return es.getplayerteam(userid)
            return 0
        
        class Index:
            def __init__(self,index,team,entity):
                self.index = index
                self.teamname = team
                self.entity = entity
                self.location = es.getindexprop(self.index,'CBaseEntity.m_vecOrigin')
                self.effect = self.getEffect(str(es.ServerVar('lt_%s_effect_%s'%(self.teamname,self.entity))))
            
            def createTrail(self):
                location = es.getindexprop(self.index,'CBaseEntity.m_vecOrigin')
                if location == self.location: return
                if self.effect == 'smoke':
                    es.effect('smoke',location,'smoke',5,0.1)
                if self.effect == 'energy':
                    es.effect('energysplash',self.location,location,0)
                if self.effect == 'sparks':
                    es.effect('sparks',self.location,1,5,location)
                if self.effect == 'dust':
                    es.effect('dust',self.location,location,100,30)
                if self.effect == 'beam':
                    model = es.precachemodel(es.ServerVar('lt_beammodel'))
                    red = es.ServerVar('lt_%s_beam_red'%self.teamname)
                    green = es.ServerVar('lt_%s_beam_green'%self.teamname)
                    blue = es.ServerVar('lt_%s_beam_blue'%self.teamname)
                    es.effect('beam',self.location,location,model,model,0,0,.7,10,10,.5,1,red,green,blue,255,30)
                self.location = location
            
            @staticmethod
            def getEffect(effect):
                if not effect in TrailEffects + ['random']: return None
                if effect == 'random': return random.choice(TrailEffects)
                return effect
    
    class Teams:
        def __init__(self, number, name):
            self.number = number
            self.name = name
            self.team_entities = {}
        
        def _registerTeamEntity(self, entity, name):
            self.team_entities[entity] = name
    
    def __init__(self):
        self.entities = {}
        self.teams = {}
    
    def _registerTeam(self, number, name):
        self.teams[number] = self.Teams(number, name)
    
    def _registerEntity(self, entity, name, teams):
        ent = self.entities[entity] = self.Entity(entity, name)
        teams = (teams,) if isinstance(teams, int) else tuple(teams)
        for team in teams:
            ent.teams[team] = self.teams[team].name.replace(' ','_').lower()
            self.teams[team]._registerTeamEntity(entity, name)
    
    def doTrail(self):
        for entity in self.entities:
            self.entities[entity].findIndexes()

ageofchivalry = EntityManager()
ageofchivalry._registerTeam(2,'Knights')
ageofchivalry._registerTeam(3,'Masons')
ageofchivalry._registerEntity('aoc_arrow','Arrows',(2,3))
ageofchivalry._registerEntity('crossbow_bolt','Crossbow Bolts',(2,3))
ageofchivalry._registerEntity('weapon_thrown_dagger2','Thrown Daggers',(2,3))
ageofchivalry._registerEntity('weapon_thrown_onehandaxe','Thrown Axes',(2,3))
ageofchivalry._registerEntity('weapon_thrown_spear','Thrown Spears',(2,3))
ageofchivalry._registerEntity('grenade_molotov','Thrown Oilpots',(2,3))
ageofchivalry._registerEntity('aoc_ballista_arrow','Ballista Arrows',(2,3))
ageofchivalry._registerEntity('aoc_eprojectile','Catapult Projectiles',(2,3))

cstrike = EntityManager()
cstrike._registerTeam(2,'Terrorists')
cstrike._registerTeam(3,'Counter-Terrorists')
cstrike._registerEntity('flashbang_projectile','Thrown Flashbangs',(2,3))
cstrike._registerEntity('hegrenade_projectile','Thrown Grenades',(2,3))
cstrike._registerEntity('smokegrenade_projectile','Thrown Smoke Grenades',(2,3))

def _getCurrentGame():
    if gamename == 'ageofchivalry':
        return ageofchivalry
    elif gamename == 'cstrike':
        return cstrike
    else:
        raise NotImplementedError, 'LooneyTrails does not currently support "%s"'%gamename

currentgame = _getCurrentGame()

def load():
    es.addons.registerTickListener(tick)
    config = cfglib.AddonCFG(es.getAddonPath('looneytrails') + '/lt_config.cfg')
    config.text(getCfgText('Weapon Entity Effect Options'))
    config.text('Possible choices for effects are "%s", and "random"'%'", "'.join(TrailEffects))
    config.text('Simply setting an effect to ANYTHING not listed above will mean there will be no effect for that entity.')
    config.text('Choosing "random" will mean each time a new entity is created of that type, it will choose a random effect for that index')
    for x in currentgame.teams:
        config.text('\n')
        team = currentgame.teams[x]
        length = '*'*len(team.name)
        config.text(getCfgText('Choose Effects for %s Weapons'%team.name))
        for y in team.team_entities:
            z = config.cvar('lt_%s_effect_%s'%(team.name.replace(' ','_').lower(),y),TrailEffects[0],'Set to the effect you wish %s to have for %s'%(team.name,team.team_entities[y]))
        config.text('')
        config.text(getCfgText('Choose Colors for %s Beams'%team.name))
        for y in ('Red','Green','Blue'):
            z = config.cvar('lt_%s_beam_%s'%(team.name.replace(' ','_').lower(),y.lower()),255,'Set the %s value for %s beam color'%(y,team.name))
    config.text('\n')
    config.text(getCfgText('Model Options'))
    lt_beammodel = config.cvar('lt_beammodel','sprites/laser.vmt','Set to model to use for beam effect')
    config.write()
    config.execute()

def getCfgText(text):
    return '%s\n// ** %s **\n// %s'%('*'*(len(text) + 6),text,'*'*(len(text) + 6))

def unload():
    es.addons.unregisterTickListener(tick)

def tick():
    currentgame.doTrail()